Ofcas.Lk.Api.Client - Version 3.0 3.0.0.113

Public Member Functions | Public Attributes | Protected Member Functions | Properties | List of all members
Ofcas.Lk.Api.Client.Core.Project Class Reference

Project is the representation of a LogiKal project. The children are of type Phase. The children can be received from the InfoList (CoreObjectWithChildren<Phase, PhaseInfo>.ChildrenInfos). More...

Inheritance diagram for Ofcas.Lk.Api.Client.Core.Project:

## Public Member Functions
IList< IProjectInformationType > | GetProjectInformations ()
| Returns all available project informations for the current Project. More...
ProjectInformationContainer | GetProjectInformationContainer (IProjectInformationType projectInformationType)
| Returns the project information container to the given project information type (IProjectInformationType). The ProjectInformationContainer allows access to the items of the corresponding project information. More...
override Phase | GetChild (PhaseInfo phaseInfo)
| Gets a Phase based on a PhaseInfo. More...
override IList< Phase > | GetChildren (IEnumerable< PhaseInfo > childrenInfos=null)
| Gets Phases based on the list of PhaseInfos. More...
Phase | GetPhase (PhaseInfo phaseInfo)
| This method is deprecated. Please use GetChild(PhaseInfo) instead. More...
override OperationInfo | CanEdit (string key, object value)
| Checks whether a project can be edited or not. More...
override ProjectInfo | Edit (string key, object value)
| Edits a project based on a key and a value. More...
PhaseInfo | CreatePhase (string name, string description)
| This method is obsolete, please use CanCreateChild() and CreateChild() instead and change the name with Edit(). See WellKnownEditKeys.Phase. More...
override OperationInfo | CanCreateChild ()
| Checks whether a phase can be created or not. More...
override PhaseInfo | CreateChild ()
| Creates a new phase with a default name. Call Phase.Edit with WellKnownEditKeys.Phase to change values. More...
IList< ReportCategory > | GetAvailableUserReports ()
| This method is deprecated. Please use GetReports instead. More...
IList< ReportCategory > | GetReports ()
| Return all available reports. More...
override PhaseInfo | RefreshChild (PhaseInfo childInfo)
OperationInfo | CanAdd (ICoreInfo coreInfo)
| Used to check if an ElevationInfo can be added to a project of type ProjectType.FabricationLot. More...
PhaseInfo | Add (ICoreInfo coreInfo)
| Used to add an ElevationInfo to a project of type ProjectType.FabricationLot. More...
override OperationInfo | CanDeleteChild (PhaseInfo childInfo)
override void | DeleteChild (PhaseInfo childInfo, bool forceDelete=false)
void | UpdatePartsLists (IEnumerable< ElevationInfo > items)
| Update the parts list for all given elevations. If an empty list is passed, an update with all elevations of the project is automatically done. More...
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
TOwnInfo | Refresh ()
Public Member Functions inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObject
bool | CanDispose ()
| Checks whether the ICoreInfo can be disposed. More...

## Public Attributes
DocumentContainer | Documents => _documentContainerLifetimeManager.GetCoreObject()

## Protected Member Functions
override IEnumerable< PhaseInfo > | GetChildrenInfos ()
virtual Phase | CreateNewInstance (Guid coreObjectId, PhaseInfo phaseInfo)
virtual ProjectInformationContainer | CreateNewInstance (Guid coreObjectId)
override void | Dispose (bool disposing)
Protected Member Functions inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
| CoreObjectFullyQualified (IServiceFactory< IApiService > serviceFactory, Guid coreObjectId, TParent parent, TOwnInfo ownInfo)
| Creates a new instance of CoreObjectFullyQualified<TParent,TOwnInfo,TChild,TChildInfo> with the given parameters. More...

## Properties
ISynchronizationContainer | SynchronizationContainer`[get]`
Properties inherited from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >
TParent | Parent`[get]`
TOwnInfo | Info`[get]`
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObjectWithDocuments
DocumentContainer | Documents`[get]`
| The DocumentContainer of the ICoreObject. More...
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObjectWithSynchronizations
ISynchronizationContainer | SynchronizationContainer`[get]`
| The ISynchronizationContainer of this ICoreObject. More...
Properties inherited from Ofcas.Lk.Api.Client.Core.Interfaces.ICoreObject
Guid | CoreObjectId`[get]`
| This property is deprecated. Please use ICoreObject.Id instead. More...
Guid | Id`[get]`
| The unique identifier of this core object. More...

## Detailed Description

Project is the representation of a LogiKal project. The children are of type Phase. The children can be received from the InfoList (CoreObjectWithChildren<Phase, PhaseInfo>.ChildrenInfos).

## Member Function Documentation

## ◆ Add()

PhaseInfo Ofcas.Lk.Api.Client.Core.Project.Add | ( | ICoreInfo | coreInfo | ) |

Used to add an ElevationInfo to a project of type ProjectType.FabricationLot.

Parameters

  coreInfo | The ElevationInfo to add.

Returns
  Returns a PhaseInfo of the FabricationLot the ElevationInfo belongs to.

## ◆ CanAdd()

OperationInfo Ofcas.Lk.Api.Client.Core.Project.CanAdd | ( | ICoreInfo | coreInfo | ) |

Used to check if an ElevationInfo can be added to a project of type ProjectType.FabricationLot.

Parameters

  coreInfo | The ElevationInfo to add.

Returns
  Returns a OperationInfo.

## ◆ CanCreateChild()

override OperationInfo Ofcas.Lk.Api.Client.Core.Project.CanCreateChild | ( |  | ) |

Checks whether a phase can be created or not.

Returns
  An OperationInfo indicating if the operation can be called.

## ◆ CanEdit()

override OperationInfo Ofcas.Lk.Api.Client.Core.Project.CanEdit | ( | string | key,
|  | object | value
| ) |  |
| virtual

Checks whether a project can be edited or not.

Parameters

  key | The key of the value to be edited. See WellKnownEditKeys.Project for all available edit keys.
  value | The value to be set.

Returns

Reimplemented from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >.

## ◆ CreateChild()

override PhaseInfo Ofcas.Lk.Api.Client.Core.Project.CreateChild | ( |  | ) |

Creates a new phase with a default name. Call Phase.Edit with WellKnownEditKeys.Phase to change values.

Returns
  Returns an info object of the created phase.

## ◆ CreatePhase()

PhaseInfo Ofcas.Lk.Api.Client.Core.Project.CreatePhase | ( | string | name,
|  | string | description
| ) |  |

This method is obsolete, please use CanCreateChild() and CreateChild() instead and change the name with Edit(). See WellKnownEditKeys.Phase.

Parameters

  name | The name of the new elevation
  description | The description of the new phase

Returns
  The PhaseInfo to the created elevation or NULL if the user rejected the dialog.

Exceptions

  ApiException | contains api error message

## ◆ Edit()

override ProjectInfo Ofcas.Lk.Api.Client.Core.Project.Edit | ( | string | key,
|  | object | value
| ) |  |
| virtual

Edits a project based on a key and a value.

Parameters

  key | The key of the value to be edited. See WellKnownEditKeys.Project for all available edit keys.
  value | The value to be set.

Returns
  Returns an info object of the edited project.

Reimplemented from Ofcas.Lk.Api.Client.Core.CoreObjectFullyQualified< ProjectCenter, ProjectInfo, Phase, PhaseInfo >.

## ◆ GetAvailableUserReports()

IList<ReportCategory> Ofcas.Lk.Api.Client.Core.Project.GetAvailableUserReports | ( |  | ) |

This method is deprecated. Please use GetReports instead.

## ◆ GetChild()

override Phase Ofcas.Lk.Api.Client.Core.Project.GetChild | ( | PhaseInfo | phaseInfo | ) |

Gets a Phase based on a PhaseInfo.

Parameters

  phaseInfo | The PhaseInfo of the Phase to be returned.

Returns
  Returns a Phase based on the given PhaseInfo.

## ◆ GetChildren()

override IList<Phase> Ofcas.Lk.Api.Client.Core.Project.GetChildren | ( | IEnumerable< PhaseInfo > | childrenInfos = `null` | ) |

Gets Phases based on the list of PhaseInfos.

Parameters

  childrenInfos | The PhaseInfos of the Phases to be returned. If an empty list is given all Phases of this Project will be returned.

Returns
  Returns a list of Phases based on the given PhaseInfos.

## ◆ GetPhase()

Phase Ofcas.Lk.Api.Client.Core.Project.GetPhase | ( | PhaseInfo | phaseInfo | ) |

This method is deprecated. Please use GetChild(PhaseInfo) instead.

## ◆ GetProjectInformationContainer()

ProjectInformationContainer Ofcas.Lk.Api.Client.Core.Project.GetProjectInformationContainer | ( | IProjectInformationType | projectInformationType | ) |

Returns the project information container to the given project information type (IProjectInformationType). The ProjectInformationContainer allows access to the items of the corresponding project information.

Parameters

  projectInformationType | The type for the project information to get.

Returns
  The ProjectInformationContainer object. The lifetime of this object must be administrated outside and can only be used, if the Project instance exists.

## ◆ GetProjectInformations()

IList<IProjectInformationType> Ofcas.Lk.Api.Client.Core.Project.GetProjectInformations | ( |  | ) |

Returns all available project informations for the current Project.

Returns
  Available project informations. These items can be used to get access to the project informations over ProjectInformationContainer

## ◆ GetReports()

IList<ReportCategory> Ofcas.Lk.Api.Client.Core.Project.GetReports | ( |  | ) |

Return all available reports.

Returns
  Reports sorted by category (ReportCategory)

## ◆ UpdatePartsLists()

void Ofcas.Lk.Api.Client.Core.Project.UpdatePartsLists | ( | IEnumerable< ElevationInfo > | items | ) |

Update the parts list for all given elevations. If an empty list is passed, an update with all elevations of the project is automatically done.

Parameters

  items | List of elevations to be used to update

The documentation for this class was generated from the following file:

- Project.cs